function(enable_doxygen)
  find_package(Doxygen COMPONENTS dot QUIET)
  if (Doxygen_FOUND)
    set(DOXYGEN_CALLER_GRAPH NO)
    set(DOXYGEN_CALL_GRAPH NO)
    set(DOXYGEN_EXTRACT_ALL YES)
    set(DOXYGEN_CLANG_ASSISTED_PARSING YES)
    set(DOXYGEN_CLANG_DATABASE_PATH "${CMAKE_BINARY_DIR}/compile_commands.json")
    set(DOXYGEN_SORT_BRIEF_DOCS YES)
    set(DOXYGEN_SORT_GROUP_NAMES YES)
    set(DOXYGEN_JAVADOC_AUTOBRIEF YES)
    set(DOXYGEN_INHERIT_DOCS YES)
    set(DOXYGEN_EXCLUDE_PATTERNS
        "*/unit_tests/*"
        "*/thirdparty/*"
        "*/depr/*"
        "*.py"
    )
    set(DOXYGEN_ENABLE_PREPROCESSING YES)
    set(DOXYGEN_MACRO_EXPANSION YES)
    set(DOXYGEN_EXPAND_ONLY_PREDEF YES)
    set(DOXYGEN_EXPAND_AS_DEFINED
      D5_DM_OP_MIXIN
      D5_DM_SINGLE_FIELD_MIXIN
      D5_DM_TM_MIXIN
      D5_FROM_JSON
      D5_RASTER_DATA_TYPES
      D5_TO_JSON
      D5_TRUTH_TYPES
    )
    set(DOXYGEN_PREDEFINED
      D5_JSON_SERIALIZE_ENUM=
    )
    set(DOXYGEN_INCLUDE_PATH "${PROJECT_SOURCE_DIR}/include")
    set(DOXYGEN_GENERATE_TREEVIEW YES)
    set(DOXYGEN_DISABLE_INDEX YES)
    set(DOXYGEN_FULL_SIDEBAR YES)
    set(DOXYGEN_IMAGE_PATH "${PROJECT_SOURCE_DIR}/docs/figures")

    doxygen_add_docs(doxygen-docs ${PROJECT_SOURCE_DIR})
    message(STATUS "Use doxygen-docs target to build C++ documentation")

    get_target_property(DOXYGEN_DIR Doxygen::doxygen LOCATION)
    cmake_path(GET DOXYGEN_DIR PARENT_PATH DOXYGEN_DIR)
    dirsig_add_dependency(Doxygen
      VERSION ${DOXYGEN_VERSION}
      INCLUDE_DIRS ${DOXYGEN_DIR}
    )
  endif()
endfunction()
