#pragma once

#include "dirsig5/base/Geometry.h"
#include "dirsig5/base/SpectralVector.h"
#include "dirsig5/base/State.h"

namespace d5::apis {

class Spectrum {
public:
  virtual ~Spectrum() = default;

  virtual void updateState(const State *) {}

  struct HitInfo {
    Vectorf rayOrg = {0, 0, 0};

    Vectorf rayDir = {0, 0, 0};

    Vectorf hitPoint = {0, 0, 0};

    Point2f hitUV = {0, 0};

    Vectorf hitNormal = {0, 0, 0};

    float time = 0;
  };

  virtual void getSpectrum(const HitInfo &, SpectralVector &) const = 0;
};

} // namespace d5::apis
