/** Interface file for the temperature model API
 *
 *  \file TemperatureModel.h
 */

#pragma once

#include "dirsig5/base/State.h"

namespace d5::apis {

/// Abstract struct for predicting the temperature of a surface.
struct TemperatureModel {
  /// Destructor
  virtual ~TemperatureModel() = default;

  /// Updates the state of the model
  virtual void updateState(const State *state) = 0;

  /// Predicts the temperature [K]
  virtual float predictTemperature() = 0;
};
} // namespace d5::apis
