#pragma once

#include <any>
#include <string>

#include "dirsig5/base/Export.h"

namespace d5 {

class D5_BASE_EXPORT Library {
public:
  Library() = default;

  Library(const std::string &filename) { open(filename); }

  [[nodiscard]] std::string error() const;

  [[nodiscard]] const std::string &filename() const noexcept {
    return filename_;
  }

  void open(const std::string &filename) noexcept;

  void close() noexcept;

  [[nodiscard]] void *resolve(const std::string &name) const;

  [[nodiscard]] operator bool() const { return handle_.has_value(); }

private:
  std::any handle_;

  std::string filename_;
};

} // namespace d5
