#pragma once

#include <mutex>

#define DIRSIG_LOCK_GUARD(mutex, ...)                                          \
  {                                                                            \
    std::lock_guard guard__{mutex};                                            \
    __VA_ARGS__                                                                \
  }

#define DIRSIG_DISTINCT_LOCK_GUARD(...)                                        \
  {                                                                            \
    static std::mutex mutex__{};                                               \
    std::lock_guard guard__{mutex__};                                          \
    __VA_ARGS__                                                                \
  }

#define DIRSIG_DISTINCT_LOCK_GUARD_IF(flag, ...)                               \
  if (flag) {                                                                  \
    DIRSIG_DISTINCT_LOCK_GUARD({                                               \
      if (flag) {                                                              \
        __VA_ARGS__                                                            \
        flag = false;                                                          \
      }                                                                        \
    })                                                                         \
  }
