/** Common interface file for macros
 *
 *  \file Macros.h
 */

#pragma once

/// \addtogroup common
/// \{

/// Reduce the boilerplate on std::forward
#define D5_FWD(...) ::std::forward<decltype(__VA_ARGS__)>(__VA_ARGS__)

/// Workaround for MSVC's nonstandard __VA_ARGS__ handling
#define D5_EXPAND(x) x

/// Macro to allow arguments with a comma
#define D5_SINGLE_ARG(...) __VA_ARGS__

/// \}
