/** Interface file for MpiState
 *
 *  \file MpiState.h
 */

#pragma once

#include <string>

#include "dirsig5/base/Export.h"

namespace d5 {

/// \addtogroup utility
/// \{

/** Singleton to handle Node specific metadata
 *
 *  TODO There has to be a better way to implement this logic than a singleton
 */
class D5_BASE_EXPORT MpiState {
public:
  MpiState(const MpiState &) = delete;

  static MpiState &GetInstance();

  // Command-Line settings
  bool frameMode = false;
  bool singleRowChunkMode = false;

  // Node Info
  int worldRank = 0;
  int worldSize = 1;
  std::string nodeName = "localhost";

private:
  MpiState() = default;
  ~MpiState() = default;
};

#define MPI_STATE d5::MpiState::GetInstance()

/// \}
} // namespace d5
