#pragma once

#include "dirsig5/base/Error.h"

namespace d5 {

/// Replaces an environment variable in the supplied string.
inline std::string ReplaceEnvVars(std::string p) {
  // check for environment variables
  if (auto startPos = p.find("${") != std::string::npos) {
    auto endPos = p.find("}", startPos);
    if (endPos == std::string::npos) {
      DIRSIG_THROW_FMT("Invalid environment variable in string: '{}'", p);
    }
    std::string varName = p.substr(startPos + 1, endPos - 2);
    auto varValue = std::getenv(varName.c_str());
    if (varValue == nullptr) {
      DIRSIG_THROW_FMT("Missing/Unknown environment variable: '{}'", varName);
    }
    p.replace(startPos - 1, endPos - startPos + 2, varValue);
  }
  return p;
}

} // namespace d5
