#pragma once

#include "dirsig5/d4legacy/platform/ImageFile.h"
#include "dirsig5/d4legacy/xml/xml.h"

namespace d5::d4legacy::platform {

struct D5_D4LEGACY_EXPORT TruthCollection final {
public:
  struct Collector final {
    std::string name{};
  };

  /// Is enabled?
  bool enabled{true};
  /// The image file.
  ImageFile imageFile{};
  /// The truth collectors.
  std::vector<Collector> collectors{};

public:
  /// Read XML. The given node is understood to be `<truthcollection>`.
  void ReadXML(const xml::Node& node) {
    enabled = true;
    if (node.attribute("enabled"))
      enabled = node.attribute("enabled").as_bool();
    imageFile.FindAndReadXMLSubnodes(node);
    collectors.clear();
    for (auto each :
         xml::requiredChild(node, "collectorlist").children("collector")) {
      Collector& collector{collectors.emplace_back()};
      collector.name = each.child("name").text().as_string();
      // TODO
      // Abundance ==> <materials>
    }
  }
};

}  // namespace d5::d4legacy::platform
