/** Interface file for SimFile
 *
 *  \file SimFile.h
 */

#pragma once

#include <memory>
#include <string>

#include "dirsig5/d4legacy/Export.h"

namespace d5::d4legacy {

/// \addtogroup d4legacy
/// \{

/** Data model for a .sim file, which is simply a collection of references to
 *  other files.
 */
class D5_D4LEGACY_EXPORT SimFile {
public:
  std::string filename;
  std::string sceneFilename;
  std::string atmosphereFilename;
  std::string platformFilename;
  std::string platformMotionFilename;
  std::string tasksFilename;
  std::string optionsFilename;

  /** Loads the SimFile from disk
   *
   *  \throw std::runtime_error  on any read error
   *  \return A pointer to the read sim file
   */
  static std::unique_ptr<SimFile> LoadFromXmlFile(const std::string& filename);
};

/// \}
}  // namespace d5::d4legacy
