/** Interface file for ENVI header I/O
 *
 *  \file HeaderIO.h
 */

#pragma once

#include <istream>

#include "Header.h"
#include "dirsig5/envi/Export.h"

namespace d5::envi {

/** Reads an ENVI header from the given stream
 *
 *  \param[in,out] is  The stream from which to consume the header
 *
 *  \return The read header
 *  \throw std::exception subclass on a read error. Line numbers will be
 *         relative to the current position of the stream (1-based).
 */
D5_ENVI_EXPORT envi::Header ReadHeader(std::istream &is);
} // namespace d5::envi
