/** Interface file for the different types of interleaving
 *
 *  \file Interleave.h
 */

#pragma once

#include <cstdint>
#include <string>

#include "dirsig5/envi/Export.h"

namespace d5::envi {

/// Constants for the different types of interleaving
enum class Interleave : std::uint8_t {
  /// Band-sequential (band, row, column indexing)
  BSQ,

  /// Band interleave-by-line (row, band, column indexing)
  BIL,

  /// Band interleave-by-pixel (row, column, band indexing)
  BIP
};

D5_ENVI_EXPORT const std::string &to_string(Interleave i);
} // namespace d5::envi
