#pragma once

#include <cmath>
#include <vector>

#include "dirsig5/flex_motion/JitterModel.h"

namespace d5::flex_motion::JitterModels {

class D5_FM_EXPORT Correlated final : public JitterModel {
public:
  [[nodiscard]] double generate(double relativeTime) const override;

public:
  struct Component {
    double frequency = 0;
    double magnitude = 0;
    double phase = 0;
    double operator()(double t) const {
      return magnitude * std::cos(2 * M_PI * frequency * t + phase);
    }
  };

  std::vector<Component> components;
};

} // namespace d5::flex_motion::JitterModels
