#pragma once

#include <cstdint>

#include "dirsig5/flex_motion/JitterModel.h"

namespace d5::flex_motion::JitterModels {

/// Temporally uncorrelated jitter.
class D5_FM_EXPORT Uncorrelated final : public JitterModel {
public:
  [[nodiscard]] double generate(double relativeTime) const override;

public:
  std::uint32_t seed = 0;

  /// The mean value for the uncorrelated jitter
  double mean = 0;

  /// The standard deviation for the uncorrelated jitter
  double stdev = 0;
};

} // namespace d5::flex_motion::JitterModels
