#pragma once

#include "dirsig5/flex_motion/LocationEngine.h"

namespace d5::flex_motion::LocationEngines {

/// An object sitting at a fixed location.
class D5_FM_EXPORT Fixed final : public LocationEngine {
public:
  Fixed() = default;

  bool isStatic() const override { return true; }

  LocationState doGet(const DateTime &, double) const override {
    return {location};
  }

public:
  /// The coordinate for the fixed location.
  Point location = {0, 0, 0};
};

} // namespace d5::flex_motion::LocationEngines
