#pragma once

#include "dirsig5/flex_motion/Mount.h"

namespace d5::flex_motion::Mounts {

class D5_FM_EXPORT Lemniscate final : public Mount {
public:
  /// The minimum across-track angle [radians]
  double minAcrossTrackAngle = 0;

  /// The maximum across-track angle [radians]
  double maxAcrossTrackAngle = 0;

  /// The minimum along-track angle [radians]
  double minAlongTrackAngle = 0;

  /// The maximum along-track angle [radians]
  double maxAlongTrackAngle = 0;

protected:
  DualQuaternion doGet(const DateTime &, double, double) const override;
};

} // namespace d5::flex_motion::Mounts
