#pragma once

#include "dirsig5/flex_motion/Mount.h"

namespace d5::flex_motion::Mounts {

/// The line or whisk mount model.
class D5_FM_EXPORT Line final : public Mount {
public:
  /// The start angle [radians]
  double startAngle = 0;

  /// The stop angle [radians]
  double stopAngle = 0;

  /// Is whisk scan? If true, bi-directionally scans the
  /// across-track axis with sinusoidal angular velocity. If false,
  /// uni-directionally scans the across-track axis with linear angular
  /// velocity.
  bool isWhisk = false;

protected:
  DualQuaternion doGet(const DateTime &, double, double) const override;
};

} // namespace d5::flex_motion::Mounts
