#pragma once

#include "dirsig5/flex_motion/RotationEngine.h"

namespace d5::flex_motion::RotationEngines {

/// An object with an orientation defined by the current velocity.
class D5_FM_EXPORT Velocity final : public RotationEngine {
public:
  Velocity() = default;

  void doUpdateState(const StateDateTime &, const geolib::Facade *) override {
    DIRSIG_THROW_IF(
        ((constraintFlags & UseVelocity) == UseVelocity),
        "Cannot use velocity constraint with velocity orientation engine!");
  }

  Quaternion doGet(const DateTime &, double) const override;
};

} // namespace d5::flex_motion::RotationEngines
