/** Implementation file for ModtranCommon.h
 *
 *  \file ModtranCommon.cpp
 */

#include "dirsig5/atmosphere/backends/ModtranCommon.h"

#include <stdexcept>

#include "dirsig5/base/Error.h"

namespace d5::atm::modtran {

static ModtranProfileCallback s_profileCallback;

void SetModtranProfileCallback(ModtranProfileCallback f) {
  s_profileCallback = std::move(f);
}

Profile GetModtranProfile(const std::string &name) {
  DIRSIG_THROW_IF(
      !s_profileCallback,
      "GetModtranProfile() called before SetModtranProfileCallback()");
  DIRSIG_ERROR_TRACE("looking up MODTRAN profile \"" + name + "\"",
                     { return s_profileCallback(name); });
}

} // namespace d5::atm::modtran
