/** Unit test for type traits
 *
 *  \file TypeTraitsTests.cpp
 */

#include "dirsig5/base/TypeTraits.h"

#include <gtest/gtest.h>

using namespace d5;

template <typename T> struct A {};

template <typename T> struct B {};

template <typename T> struct C {};

template <typename T> struct D {};

TEST(TypeTraitsTest, HasValueMemberTest) {
  static_assert(has_value_member_v<std::true_type>);
  static_assert(!has_value_member_v<A<int>>);
}

TEST(TypeTraitsTest, IsSameTmplTest) {
  static_assert(is_same_tmpl_v<A, A>);
  static_assert(!is_same_tmpl_v<A, B>);
}

TEST(TypeTraitsTest, IsAnyTmplTest) {
  static_assert(is_any_tmpl_v<A, A, B, C, D>);
  static_assert(is_any_tmpl_v<B, A, B, C, D>);
  static_assert(is_any_tmpl_v<C, A, B, C, D>);
  static_assert(is_any_tmpl_v<D, A, B, C, D>);
  static_assert(!is_any_tmpl_v<D, A, B, C>);
}
