#pragma once

#include <utility>
#include <vector>

namespace d5::brdf {

template <typename Struct>
inline void Unzip(
    const std::vector<Struct>& input,
    const std::vector<std::pair<double Struct::*, std::vector<double>*>>&
        outputs) {
  for (auto& [member, output] : outputs) {
    output->clear();
    output->reserve(input.size());
    for (const auto& each : input) output->push_back(each.*member);
  }
}

}  // namespace d5::brdf
