/** Implementation file for height models
 *
 *  \file HeightModel.cpp
 */

#include "dirsig5/d4legacy/geometry/HeightModel.h"

#include <ostream>
#include <sstream>

namespace d5::d4legacy {

std::ostream& operator<<(std::ostream& os, const HeightModel& hm) {
  os << to_string(hm.type());
  return os;
}

std::string to_string(HeightModel::Type type) {
  switch (type) {
    case HeightModel::Type::Wave:
      return "Wave";
    case HeightModel::Type::Image:
      return "Image";
    case HeightModel::Type::Unknown:
    default:
      return "unknown";
  }
}
}  // namespace d5::d4legacy
