#include "dirsig5/d4legacy/image_io/RasterDataIO.h"

#include "dirsig5/base/Error.h"
#include "dirsig5/base/Logger.h"
#include "dirsig5/raster/ReadRaster.h"

namespace d5::d4legacy {

raster::Raster ReadRasterDataFromFile(
  const char* filename, const RasterReadOptions& options) {
  apis::RasterInputRead::In in;
  in.path = filename;
  in.loadAsGrayscale = options.readAsGrayscale();
  auto result = raster::ReadRaster(in);
  DIRSIG_THROW_IF_FMT(
    options.readAsGrayscale() && result.channels() != 1,
    "Image was requested as grayscale, but it had {} "
    "channels that were not convertible",
    result.channels());
  return result;
}

}  // namespace d5::d4legacy
