/** Implementation file for dealing with absorption files
 *
 *  \file AbsorptionFile.cpp
 */

#include "dirsig5/d4legacy/mat/AbsorptionFile.h"

#include <fstream>

#include "dirsig5/base/Error.h"
#include "dirsig5/d4legacy/mat/SimpleSpectralData.h"

namespace d5::d4legacy {

AbsorptionData AbsorptionData::ReadFromFile(const std::string& filename) {
  AbsorptionData ad;

  auto ssd = ReadSimpleSpectralDataFromFile(
    filename.c_str(), SimpleSpectralData::Format::Text);
  ad.wavenumber = std::move(ssd.wavelengthsMicron);
  ad.absInvPpmM = std::move(ssd.spectrum);
  return ad;
}
}  // namespace d5::d4legacy
