/** Interface file for bulk property I/O
 *
 *  \file BulkPropertiesIO.h
 */

#pragma once

#include "dirsig5/d4legacy/mat/BulkProperties.h"
#include "dirsig5/d4legacy/tag/TagFileElement.h"

namespace d5::d4legacy {

/** Loads bulk properties from a BULK_PROPERTIES section
 *
 *  \param section  The BULK_PROPERTIES section in the tag file
 *
 *  \return The loaded bulk properties
 */
BulkProperties LoadBulkProperties(const TagFileSection& section);
}
