#include "dirsig5/d4legacy/plumes/Blackadar.h"

namespace d5::d4legacy {

void BlackadarData::ReadXML(const xml::Node& node) {
  directInsolation = node.child("directinsolation").text().as_double();
  airTemperature = node.child("airtemperature").text().as_double();
  windSpeed = node.child("windspeed").text().as_double();
  windDirection = node.child("winddirection").text().as_double();
  surfaceRoughness = node.child("surfaceroughness").text().as_double();
  mixedAltitude = node.child("mixedaltitude").text().as_double();
  stackLocation = xml::readCoordinate(node, "stacklocation");
  stackHeight = node.child("stackheight").text().as_double();
  stackDiameter = node.child("stackdiameter").text().as_double();
  releaseBuoyancy = node.child("releasebuoyancy").text().as_double();
  releaseTemperature = node.child("releasetemperature").text().as_double();
  stepCount = node.child("stepcount").text().as_int();
  puffsPerStep = node.child("puffsperstep").text().as_int();
  plumeMaterialId = node.child("plumematerialid").text().as_string();
  releaseRate = node.child("releaserate").text().as_double();
  debugFilename = node.child("debugfilename").text().as_string();
  stepTime = node.child("steptime").text().as_double(-1);
}

}  // namespace d5::d4legacy
