#include "dirsig5/d4legacy/mat/MatFile.h"

#include <sstream>

#include <gtest/gtest.h>

#include "CLTemporaryFile.h"

namespace test {

TEST(D4LegacyMatFileTest, LoadFromStringTest) {
  auto matFile = d5::MakeTempFile(".mat");
  matFile << R"(
MATERIAL_ENTRY {
    NAME = 60% Lambertian, White
    ID = 10
    EDITOR_COLOR = 1.0000, 1.0000, 1.0000
    DOUBLE_SIDED = TRUE

    SURFACE_PROPERTIES {
        REFLECTANCE_PROP_NAME = WardBRDF
        REFLECTANCE_PROP {
            DS_WEIGHTS = 0.6 0.0   
            XY_SIGMAS = 0.0 0.0
        }
    }

    RAD_SOLVER_NAME = Simple
    RAD_SOLVER {
        QUALITY = LOW
    }
}
)";
  matFile.close();

  std::unique_ptr<d5::d4legacy::MatFile> f;
  ASSERT_NO_THROW(f = d5::d4legacy::MatFile::LoadFromFile(matFile.filename()));
}

}  // namespace test
