/** ENVI Header I/O for DataType.h
 *
 *  \file DataTypeIO.h
 */

#pragma once

#include "HeaderFieldIO.h"
#include "dirsig5/base/DType.h"

namespace d5::envi {

template <>
struct header_field_io<DType, void> {
  static void serialize(std::string& str, DType val) {
    serialize_header_field(str, static_cast<std::uint8_t>(val));
  }

  static void deserialize(const std::string& str, DType& val) {
    uint8_t v;
    deserialize_header_field(str, v);
    val = static_cast<DType>(v);
  }
};

}  // namespace d5::envi
