/** Implementation file for ENVI headers
 *
 *  \file Header.cpp
 */

#include "dirsig5/envi/Header.h"

namespace {

static const std::string kReal = "Real", kImaginary = "Imaginary",
                         kPower = "Power", kMagnitude = "Magnitude",
                         kPhase = "Phase", kNone = "none", kBipolar = "bipolar",
                         kEqualization = "equalization", kGaussian = "Gaussian",
                         kLinear = "linear", kLogarithmic = "logarithmic",
                         kOptimizedLinear = "optimized linear",
                         kSquareRoot = "square root";
}

const std::string &d5::envi::to_string(Header::ComplexFunction c) {
  switch (c) {
  case Header::ComplexFunction::Real:
    return kReal;
  case Header::ComplexFunction::Imaginary:
    return kImaginary;
  case Header::ComplexFunction::Power:
    return kPower;
  case Header::ComplexFunction::Magnitude:
    return kMagnitude;
  case Header::ComplexFunction::Phase:
    return kPhase;
  }

  throw std::domain_error("invalid complex function");
}
