/** Implementation file for the different types of interleaving
 *
 *  \file Interleave.h
 */

#include "dirsig5/envi/Interleave.h"

#include <stdexcept>

// String constants
namespace {
static const std::string kBSQ = "bsq", kBIP = "bip", kBIL = "bil";
}

const std::string &d5::envi::to_string(Interleave i) {
  switch (i) {
  case Interleave::BSQ:
    return kBSQ;
  case Interleave::BIP:
    return kBIP;
  case Interleave::BIL:
    return kBIL;
  }

  throw std::domain_error("invalid interleave");
}
