/** Implementation file for WavelengthUnits.h
 *
 *  \file WavelengthUnits.cpp
 */

#include "dirsig5/envi/WavelengthUnits.h"

#include <stdexcept>

static const std::string kMicrometers = "Micrometers",
                         kNanometers = "Nanometers",
                         kMillimeters = "Millimeters",
                         kCentimeters = "Centimeters", kMeters = "Meters",
                         kAngstroms = "Angstroms", kWavenumber = "Wavenumber",
                         kGHz = "GHz", kMHz = "MHz", kIndex = "Index",
                         kUnknown = "Unknown";

const std::string &d5::envi::to_string(WavelengthUnits val) {
  switch (val) {
  case WavelengthUnits::Micrometers:
    return kMicrometers;
  case WavelengthUnits::Nanometers:
    return kNanometers;
  case WavelengthUnits::Millimeters:
    return kMillimeters;
  case WavelengthUnits::Centimeters:
    return kCentimeters;
  case WavelengthUnits::Meters:
    return kMeters;
  case WavelengthUnits::Angstroms:
    return kAngstroms;
  case WavelengthUnits::Wavenumbers:
    return kWavenumber;
  case WavelengthUnits::GHz:
    return kGHz;
  case WavelengthUnits::MHz:
    return kMHz;
  case WavelengthUnits::Index:
    return kIndex;
  case WavelengthUnits::Unknown:
    return kUnknown;
  }
  throw std::domain_error("invalid wavelengths units value");
}
