/** ENVI Header I/O for WavelengthUnits.h
 *
 *  \file WavelengthUnitsIO.h
 */

#pragma once

#include "HeaderFieldIO.h"
#include "dirsig5/envi/WavelengthUnits.h"

namespace d5::envi {

template <>
struct header_field_io<WavelengthUnits, void> {
  static void serialize(std::string& str, WavelengthUnits val) {
    str = to_string(val);
  }

  static void deserialize(const std::string& str, WavelengthUnits& val) {
    if (str == "Micrometers" || str == "um") {
      val = WavelengthUnits::Micrometers;
    } else if (str == "Nanometers" || str == "nm") {
      val = WavelengthUnits::Nanometers;
    } else if (str == "Millimeters" || str == "mm") {
      val = WavelengthUnits::Millimeters;
    } else if (str == "Centimeters" || str == "cm") {
      val = WavelengthUnits::Centimeters;
    } else if (str == "Meters" || str == "m") {
      val = WavelengthUnits::Meters;
    } else if (str == "Wavenumber") {
      val = WavelengthUnits::Wavenumbers;
    } else if (str == "Angstroms") {
      val = WavelengthUnits::Angstroms;
    } else if (str == "GHz") {
      val = WavelengthUnits::GHz;
    } else if (str == "MHz") {
      val = WavelengthUnits::MHz;
    } else if (str == "Index") {
      val = WavelengthUnits::Index;
    } else if (str == "Unknown") {
      val = WavelengthUnits::Unknown;
    } else {
      throw std::domain_error("unsupported wavelength units");
    }
  }
};
}
