#include "dirsig5/flex_motion/JitterModels/Uncorrelated.h"

#include <cmath>
#include <cstring>
#include <random>

#include "dirsig5/base/Constants.h"
#include "dirsig5/base/Pcg.h"

namespace d5::flex_motion::JitterModels {

double Uncorrelated::generate(double relativeTime) const {
  std::uint64_t stream = 0;
  std::memcpy(&stream, &relativeTime, 8);
  Pcg32 prng(seed, stream);
  double sample1 = std::generate_canonical<float, 32>(prng);
  double sample2 = std::generate_canonical<float, 32>(prng);
  return mean + stdev * (std::sqrt(-2 * std::log(sample1)) *
                         std::cos(d5::TwoPI * sample2));
}

} // namespace d5::flex_motion::JitterModels
