#include "dirsig5/flex_motion/Motions/Flex.h"

namespace d5::flex_motion::Motions {

void Flex::doUpdateState(const StateDateTime &state,
                         const geolib::Facade *facade) {
  if (locationEngine)
    locationEngine->updateState(state, facade);
  if (rotationEngine)
    rotationEngine->updateState(state, facade);
}

DualQuaternion Flex::doGet(const DateTime &dateTime) const {
  Point location(0, 0, 0);
  Quaternion rotation(1, 0, 0, 0);
  if (locationEngine)
    location = locationEngine->get(dateTime).location;
  if (rotationEngine)
    rotation = rotationEngine->get(dateTime).normalized();
  return DualQuaternion(rotation, location);
}

} // namespace d5::flex_motion::Motions
