#include "dirsig5/flex_motion/Mounts/Line.h"

#include "dirsig5/base/Constants.h"

namespace d5::flex_motion::Mounts {

DualQuaternion Line::doGet(const DateTime &, double, double scanFrac) const {
  if (isWhisk)
    scanFrac = 0.5 - 0.5 * std::cos(d5::TwoPI * scanFrac);
  double angle = (1 - scanFrac) * startAngle + scanFrac * stopAngle;
  return DualQuaternion(Quaternion(Eigen::AngleAxisd(angle, Vector::UnitY())),
                        Point(0, 0, 0));
}

} // namespace d5::flex_motion::Mounts
